#!/usr/bin/env python
# -*- coding: ISO-8859-1 -*-

import irclib
import os.path
import re

from random import *

bot_chans  = '#remouleur'               # canaux (spars par des virgules)
bot_host   = 'localhost'                # serveur
bot_port   = 6667                       # port sur le serveur IRC
bot_ident  = 'remouleur'                # nick ET ident du bot
op         = 'rguy@helix.jext.org'      # masque de l'administrateur (c'est une regex)

class RemouleurBot(irclib.IRCBot):
  def __init__(self, host, port, ident, chans):
    irclib.IRCBot.__init__(self, host, port, ident, ident, host, chans)
    self.addProcess("MESSAGE", self.processMessage)
    self.connection.setNick(ident)
    irclib.irclib_debug = 1

  def processMessage(self, args):
    id, nick, source, text = args
    if re.search(op, id) is not None:
      match = re.search('^' + self.connection.getNick() + ', (.*)$', text)
      if match is not None:
        command = match.group(1)
        if command == 'quit':
          self.connection.send("QUIT :Bye'cha !\r\n")
          self.connection.closeConnection()

    if chr(int(re.search('0\.(\d\d)', str(Random().random())).group(1))) in nick.upper():
      self.send(source, "BOUM ! V'LA L'REMOULEUR !")

if __name__ == '__main__':
  if os.path.exists('remouleur.conf'):
    conf = open('remouleur.conf')
    lines = conf.readlines()
    conf.close()
  
    for line in lines:
      match = re.search('^([^=]*)=(.*)$', line)
      if match is not None:
        key, value = match.groups(2)
        if   key == 'BOT_CHANS': bot_chans = value
        elif key == 'BOT_HOST' : bot_host  = value
        elif key == 'BOT_PORT' : bot_port  = int(value)
        elif key == 'BOT_IDENT': bot_ident = value
        elif key == 'OP'       : op        = '(\+.)?' + value.replace('.', '\.').replace('*', '.*')

  bot = RemouleurBot(bot_host, bot_port, bot_ident, bot_chans)
  bot.run()